You cannot select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

964 lines
25 KiB
Bash

9 years ago
#!/usr/bin/env bash
5 years ago
# shellcheck disable=SC2128,SC2230,SC1090
9 years ago
# vim:ts=4:sts=4:sw=4:et
#
# Author: Hari Sekhon
# Date: 2015-05-25 01:38:24 +0100 (Mon, 25 May 2015)
#
5 years ago
# https://github.com/harisekhon/devops-bash-tools
9 years ago
#
# License: see accompanying Hari Sekhon LICENSE file
#
# If you're using my code you're welcome to connect with me on LinkedIn and optionally send me feedback to help improve or steer this or other code I publish
#
# https://www.linkedin.com/in/harisekhon
9 years ago
#
set -eu
[ -n "${DEBUG:-}" ] && set -x
5 years ago
srcdir_bash_tools_utils="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"
9 years ago
7 years ago
if [ "${bash_tools_utils_imported:-0}" = 1 ]; then
return 0
fi
7 years ago
bash_tools_utils_imported=1
7 years ago
4 years ago
export PATH="$PATH:/usr/local/bin"
. "$srcdir_bash_tools_utils/ci.sh"
5 years ago
. "$srcdir_bash_tools_utils/docker.sh"
5 years ago
. "$srcdir_bash_tools_utils/os.sh"
4 years ago
. "$srcdir_bash_tools_utils/mac.sh"
5 years ago
. "$srcdir_bash_tools_utils/perl.sh"
5 years ago
. "$srcdir_bash_tools_utils/../.bash.d/colors.sh"
5 years ago
#. "$srcdir_bash_tools_utils/python.sh"
#. "$srcdir_bash_tools_utils/ruby.sh"
5 years ago
7 years ago
# consider adding ERR as set -e handler, not inherited by shell funcs / cmd substitutions / subshells without set -E
8 years ago
export TRAP_SIGNALS="INT QUIT TRAP ABRT TERM EXIT"
4 years ago
# prevents illegal byte encoding errors when piping to filenames with unicode characters
export LC_ALL=en_US.UTF-8
7 years ago
if [ -z "${run_count:-}" ]; then
run_count=0
fi
if [ -z "${total_run_count:-}" ]; then
total_run_count=0
fi
# ERE format (egrep / grep -E)
5 years ago
#
# used in client scripts
# shellcheck disable=SC2034
5 years ago
domain_regex='\b(([A-Za-z0-9](-?[A-Za-z0-9])*)\.)+[A-Za-z]{2,}\b'
5 years ago
# shellcheck disable=SC2034
email_regex='\b[A-Za-z0-9._%+-]+@[A-Za-z0-9.-]+\.[A-Za-z]{2,}\b'
5 years ago
# shellcheck disable=SC2034
ip_regex='[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}'
7 years ago
wrong_port=1111
8 years ago
die(){
4 years ago
echo "$@" >&2
8 years ago
exit 1
}
9 years ago
hr(){
echo "================================================================================"
7 years ago
}
hr2(){
7 years ago
echo "=================================================="
}
hr3(){
7 years ago
echo "========================================"
9 years ago
}
9 years ago
section(){
5 years ago
name="$*"
9 years ago
hr
5 years ago
"$srcdir_bash_tools_utils/../center.sh" "$@"
9 years ago
hr
7 years ago
if [ -n "${PROJECT:-}" ]; then
echo "PROJECT: $PROJECT"
fi
7 years ago
if is_inside_docker; then
echo "(running inside docker)"
fi
8 years ago
echo
9 years ago
}
7 years ago
section2(){
hr2
hr2echo "$@"
hr2
echo
}
section3(){
hr3
hr3echo "$@"
hr3
echo
}
hr2echo(){
5 years ago
"$srcdir_bash_tools_utils/../center.sh" "$@" 50
7 years ago
}
hr3echo(){
5 years ago
"$srcdir_bash_tools_utils/../center.sh" "$@" 40
7 years ago
}
7 years ago
#set +o pipefail
7 years ago
#spark_home="$(ls -d tests/spark-*-bin-hadoop* 2>/dev/null | head -n 1)"
7 years ago
#set -o pipefail
7 years ago
#if [ -n "$spark_home" ]; then
# export SPARK_HOME="$spark_home"
#fi
9 years ago
5 years ago
# shellcheck disable=SC1090
5 years ago
type isExcluded &>/dev/null || . "$srcdir_bash_tools_utils/excluded.sh"
9 years ago
5 years ago
6 years ago
check_bin(){
5 years ago
local bin="${1:-}"
if ! type -P "$bin" &>/dev/null; then
5 years ago
echo "command '$bin' not found in \$PATH ($PATH)"
5 years ago
if is_CI; then
echo "Running in CI, searching entire system for '$bin'"
find / -type f -name "$bin" 2>/dev/null
fi
6 years ago
exit 1
fi
}
5 years ago
check_output(){
local expected="$1"
5 years ago
local cmd="${*:2}"
8 years ago
# do not 2>&1 it will cause indeterministic output even with python -u so even tail -n1 won't work
7 years ago
echo "check_output: $cmd"
echo "expecting: $expected"
5 years ago
local output
output="$($cmd)"
# intentionally not quoting so that we can use things like google* glob matches for google.com and google.co.uk
5 years ago
# shellcheck disable=SC2053
8 years ago
if [[ "$output" = $expected ]]; then
7 years ago
echo "SUCCESS: $output"
else
7 years ago
die "FAILED: $output"
fi
echo
}
8 years ago
check_exit_code(){
5 years ago
local exit_code=$?
5 years ago
local expected_exit_codes
expected_exit_codes="$*"
local failed
failed=1
8 years ago
for e in $expected_exit_codes; do
5 years ago
if [ "$exit_code" = "$e" ]; then
7 years ago
echo "got expected exit code: $e"
8 years ago
failed=0
fi
done
5 years ago
if [ "$failed" != 0 ]; then
8 years ago
echo "WRONG EXIT CODE RETURNED! Expected: '$expected_exit_codes', got: '$exit_code'"
7 years ago
return 1
8 years ago
fi
}
5 years ago
tick_msg(){
5 years ago
# defined in .bash.d/colors.sh
# shellcheck disable=SC2154
5 years ago
echo -e "${bldgrn}✓ ${txtrst}$*"
}
6 years ago
cpu_count(){
5 years ago
if type -P nproc &>/dev/null; then
nproc
elif is_mac; then
6 years ago
cpu_count="$(sysctl -n hw.ncpu)"
else
5 years ago
#cpu_count="$(awk '/^processor/ {++n} END {print n+1}' /proc/cpuinfo)"
cpu_count="$(grep -c '^processor[[:space:]]*:' /proc/cpuinfo)"
6 years ago
fi
echo "$cpu_count"
}
4 years ago
has_terminal(){
[ -t 0 ]
}
4 years ago
is_tty(){
has_terminal
}
is_piped(){
! [ -t 1 ]
}
4 years ago
# beware this results false in scripts, has_terminal is probably what you want
is_interactive(){
if [ -n "${PS1:-}" ]; then
return 0
fi
4 years ago
case "$-" in
*i*) return 0
esac
return 1
8 years ago
}
5 years ago
if [ $EUID -eq 0 ]; then
sudo=""
else
sudo=sudo
fi
5 years ago
export sudo
8 years ago
is_latest_version(){
7 years ago
# permit .* as we often replace version if latest with .* to pass regex version tests, which allows this to be called any time
5 years ago
if [ "$version" = "latest" ] || [ "$version" = ".*" ]; then
return 0
fi
return 1
}
5 years ago
is_curl_min_version(){
local target_version="$1"
local curl_version
curl_version="$(curl --version | awk '{print $2; exit}' | grep -Eo '[[:digit:]]+\.[[:digit:]]+')"
4 years ago
bc_bool "$curl_version >= $target_version"
}
bc_bool(){
# bc returns 1 when expression is true and zero otherwise, but this is counterintuitive
# to regular shell scripting, let's use the actual output 1 for true, 0 for false
# echo rather than <<< to show expression to evaluate in trace debugging
echo "$@" | bc -l | grep -q 1
5 years ago
}
8 years ago
# useful for cutting down on number of noisy docker tests which take a long time but more importantly
# cause the CI builds to fail with job logs > 4MB
8 years ago
ci_sample(){
5 years ago
local versions
5 years ago
versions="${*:-}"
5 years ago
# longer time limits on GitHub Workflows than other CI systems like Travis so don't sample, run everything
if is_github_workflow; then
echo "$versions"
elif [ -n "${SAMPLE:-}" ] || is_CI; then
8 years ago
if [ -n "$versions" ]; then
8 years ago
local a
8 years ago
IFS=' ' read -r -a a <<< "$versions"
5 years ago
local highest_index
highest_index="${#a[@]}"
local random_index
random_index="$((RANDOM % highest_index))"
8 years ago
echo "${a[$random_index]}"
8 years ago
else
8 years ago
return 1
8 years ago
fi
else
if [ -n "$versions" ]; then
echo "$versions"
8 years ago
fi
fi
return 0
}
8 years ago
4 years ago
trap_cmd(){
# shellcheck disable=SC2064,SC2086
trap "$@" $TRAP_SIGNALS
}
8 years ago
untrap(){
5 years ago
# shellcheck disable=SC2086
8 years ago
trap - $TRAP_SIGNALS
}
8 years ago
8 years ago
plural(){
plural="s"
5 years ago
local num
num="${1:-}"
8 years ago
if [ "$num" = 1 ]; then
plural=""
fi
}
plural_str(){
5 years ago
local parts=("$@")
8 years ago
plural ${#parts[@]}
}
# =================================
#
# these functions are too clever and dynamic but save a lot of duplication in nagios-plugins test_*.sh scripts
#
7 years ago
print_debug_env(){
echo
7 years ago
echo "Environment for Debugging:"
echo
7 years ago
if [ -n "${VERSION:-}" ]; then
echo "VERSION: $VERSION"
echo
fi
7 years ago
if [ -n "${version:-}" ]; then
7 years ago
echo "version: $version"
echo
fi
7 years ago
# multiple name support for MySQL + MariaDB variables
5 years ago
for name in "$@"; do
name="$(tr '[:lower:]' '[:upper:]' <<< "$name")"
7 years ago
#eval echo "export ${name}_PORT=$`echo ${name}_PORT`"
# instead of just name_PORT, find all PORTS in environment and print them
# while read line to preserve CASSANDRA_PORTS=7199 9042
5 years ago
env | grep -E -- "^$name.*_" | grep -v -e 'DEFAULT=' -e 'VERSIONS=' | sort | while read -r env_var; do
7 years ago
# sed here to quote export CASSANDRA_PORTS=7199 9042 => export CASSANDRA_PORTS="7199 9042"
7 years ago
eval echo "'export $env_var'" | sed 's/=/="/;s/$/"/'
7 years ago
done
echo
done
}
7 years ago
trap_debug_env(){
5 years ago
local name
name="$1"
# stop CI systems from running out of space due to accumulated docker images as that causes build failures
if is_CI &&
! type trap_function &>/dev/null &&
5 years ago
type docker_image_cleanup &>/dev/null; then
trap_function(){
docker_image_cleanup
}
fi
5 years ago
# shellcheck disable=SC2086,SC2154
trap 'result=$?; type trap_function >/dev/null 2>/dev/null && trap_function; print_debug_env '"$*"'; untrap; exit $result' $TRAP_SIGNALS
}
5 years ago
is_debug(){
[ -n "${DEBUG:-}" ]
}
5 years ago
pass(){
read_secret "password"
5 years ago
export PASSWORD="$secret"
5 years ago
}
read_secret(){
secret=""
5 years ago
prompt="Enter ${1:-secret value}: "
while IFS= read -p "$prompt" -r -s -n 1 char; do
if [[ "$char" == $'\0' ]]; then
break
fi
prompt='*'
secret="${secret}${char}"
done
echo
5 years ago
export secret
}
5 years ago
# fails interactive import without this
function run++ () {
7 years ago
#if [[ "$run_count" =~ ^[[:digit:]]+$ ]]; then
((run_count+=1))
7 years ago
#fi
}
run(){
if [ -n "${ERRCODE:-}" ]; then
run_fail "$ERRCODE" "$@"
else
run++
echo "$@"
"$@"
# run_fail does it's own hr
hr
fi
}
7 years ago
run_conn_refused(){
echo "checking connection refused:"
7 years ago
ERRCODE=2 run_grep "Connection refused|Can't connect|Could not connect to|ConnectionClosed" "$@" -H localhost -P "$wrong_port"
7 years ago
}
7 years ago
run_404(){
echo "checking 404 Not Found:"
ERRCODE=2 run_grep "404 Not Found" "$@"
}
7 years ago
run_timeout(){
echo "checking timeout:"
ERRCODE=3 run_grep "timed out" "$@"
}
run_usage(){
echo "checking usage / parsing:"
6 years ago
ERRCODE=3 run_grep "usage: " "$@"
}
run_output(){
5 years ago
local expected_output
expected_output="$1"
shift
run++
echo "$@"
set +e
check_output "$expected_output" "$@"
set -e
hr
}
run_fail(){
5 years ago
local expected_exit_code
expected_exit_code="$1"
shift
run++
echo "$@"
set +e
"$@"
7 years ago
# intentionally don't quote $expected_exit_code so that we can pass multiple exit codes through first arg and have them expanded here
5 years ago
# shellcheck disable=SC2086
7 years ago
check_exit_code $expected_exit_code || exit 1
set -e
hr
}
7 years ago
run_grep(){
5 years ago
local egrep_pattern
egrep_pattern="$1"
7 years ago
shift
expected_exit_code="${ERRCODE:-0}"
7 years ago
run++
echo "$@"
set +eo pipefail
7 years ago
# pytools programs write to stderr, must test this for connection refused type information
output="$("$@" 2>&1)"
7 years ago
if ! check_exit_code "$expected_exit_code"; then
echo "$output"
exit 1
fi
7 years ago
set -e
# this must be egrep -i because (?i) modifier does not work
echo "> | tee /dev/stderr | grep -Eqi '$egrep_pattern'"
echo "$output" | tee /dev/stderr | grep -Eqi -- "$egrep_pattern"
7 years ago
set -o pipefail
hr
7 years ago
}
run_test_versions(){
5 years ago
local name
name="$1"
local test_func
test_func="$(tr '[:upper:]' '[:lower:]' <<< "test_${name/ /_}")"
local VERSIONS
VERSIONS="$(tr '[:lower:]' '[:upper:]' <<< "${name/ /_}_VERSIONS")"
# shellcheck disable=SC2006
5 years ago
local test_versions
# shellcheck disable=SC2046,SC2006,SC2116
test_versions="$(eval ci_sample $`echo "$VERSIONS"`)"
local test_versions_ordered
test_versions_ordered="$test_versions"
6 years ago
if [ -z "${NO_VERSION_REVERSE:-}" ]; then
5 years ago
# tail -r works on Mac but not Travis CI Ubuntu Trusty
4 years ago
test_versions_ordered="$(tr ' ' '\n' <<< "$test_versions" | tac | tr '\n' ' ')"
6 years ago
fi
5 years ago
local start_time
start_time="$(start_timer "$name tests")"
6 years ago
for version in $test_versions_ordered; do
7 years ago
version_start_time="$(start_timer "$name test for version: $version")"
7 years ago
run_count=0
eval "$test_func" "$version"
7 years ago
if [ $run_count -eq 0 ]; then
echo "NO TEST RUNS DETECTED!"
exit 1
fi
5 years ago
((total_run_count+=run_count))
7 years ago
time_taken "$version_start_time" "$name version '$version' tests completed in"
7 years ago
echo
done
if [ -n "${NOTESTS:-}" ]; then
print_debug_env "$name"
else
untrap
echo "All $name tests succeeded for versions: $test_versions"
7 years ago
echo
echo "Total Tests run: $total_run_count"
7 years ago
time_taken "$start_time" "All version tests for $name completed in"
echo
fi
echo
}
# =================================
5 years ago
stat_bytes(){
if is_mac; then
5 years ago
stat -f %z "$@"
5 years ago
else
5 years ago
stat -c %s "$@"
5 years ago
fi
}
8 years ago
timestamp(){
printf "%s" "$(date '+%F %T') $*" >&2
5 years ago
if [ $# -gt 0 ]; then
printf '\n' >&2
fi
8 years ago
}
7 years ago
tstamp(){ timestamp "$@"; }
8 years ago
4 years ago
log(){
if [ -n "${VERBOSE:-}" ]; then
timestamp "$@"
fi
}
start_timer(){
5 years ago
tstamp "Starting $*
"
date '+%s'
}
time_taken(){
echo
5 years ago
local start_time
# workaround if 2>&1 captures message from start_timer and only want final epoch timestamp
start_time="${1//*[[:space:]]}"
shift
local time_taken
5 years ago
local msg
msg="${*:-Completed in}"
tstamp "Finished"
echo
5 years ago
local end_time
end_time="$(date +%s)"
time_taken="$((end_time - start_time))"
echo "$msg $time_taken secs"
echo
}
5 years ago
# args may be passed in client code
# shellcheck disable=SC2120
startupwait(){
startupwait="${1:-30}"
if is_CI; then
((startupwait*=2))
fi
}
# trigger to set a sensible default if we forget, as it is used
# as a fallback in when_ports_available and when_url_content below
5 years ago
# shellcheck disable=SC2119
startupwait
8 years ago
when_ports_available(){
7 years ago
local max_secs="${1:-}"
if ! [[ "$max_secs" =~ ^[[:digit:]]+$ ]]; then
max_secs="$startupwait"
else
shift
fi
local host="${1:-}"
5 years ago
local ports="${*:2}"
local retry_interval="${RETRY_INTERVAL:-1}"
if [ -z "$host" ]; then
echo "$FUNCNAME: host \$2 not set"
7 years ago
exit 1
7 years ago
elif [ -z "$ports" ]; then
echo "$FUNCNAME: ports \$3 not set"
7 years ago
exit 1
else
for port in $ports; do
if ! [[ "$port" =~ ^[[:digit:]]+$ ]]; then
echo "$FUNCNAME: invalid non-numeric port argument '$port'"
exit 1
fi
done
7 years ago
fi
if ! [[ "$retry_interval" =~ ^[[:digit:]]+$ ]]; then
echo "$FUNCNAME: invalid non-numeric \$RETRY_INTERVAL '$retry_interval'"
exit 1
fi
7 years ago
# Linux nc doens't have -z switch like Mac OSX version
7 years ago
#local nc_cmd="nc -vw $retry_interval $host <<< ''"
#cmd=""
#for x in $ports; do
# cmd="$cmd $nc_cmd $x &>/dev/null && "
#done
#local cmd="${cmd% && }"
5 years ago
# shellcheck disable=SC2086
8 years ago
plural_str $ports
echo "waiting for up to $max_secs secs for port$plural '$ports' to become available, retrying at $retry_interval sec intervals"
7 years ago
#echo "cmd: ${cmd// \&\>\/dev\/null}"
8 years ago
local found=0
if type -P nc &>/dev/null; then
try_number=0
# special built-in that increments for script runtime, reset to zero exploit it here
SECONDS=0
# bash will interpolate from string for correct numeric comparison and safer to quote vars
while [ "$SECONDS" -lt "$max_secs" ]; do
5 years ago
((try_number+=1))
7 years ago
for port in $ports; do
if ! nc -vw "$retry_interval" "$host" "$port" <<< '' &>/dev/null; then
timestamp "$try_number waiting for host '$host' port '$port'"
sleep "$retry_interval"
break
fi
8 years ago
found=1
7 years ago
done
if [ $found -eq 1 ]; then
8 years ago
break
fi
done
if [ $found -eq 1 ]; then
timestamp "host '$host' port$plural '$ports' available after $SECONDS secs"
8 years ago
else
8 years ago
timestamp "host '$host' port$plural '$ports' still not available after '$max_secs' secs, giving up waiting"
7 years ago
return 1
8 years ago
fi
else
7 years ago
echo "WARNING: nc command not found in \$PATH, cannot check port availability, skipping port checks, tests may fail due to race conditions on service availability"
echo "sleeping for '$max_secs' secs instead"
8 years ago
sleep "$max_secs"
8 years ago
fi
}
8 years ago
# Do not use this on docker containers
# docker mapped ports still return connection succeeded even when the process mapped to them is no longer listening inside the container!
# must be the result of docker networking
when_ports_down(){
local max_secs="${1:-}"
if ! [[ "$max_secs" =~ ^[[:digit:]]+$ ]]; then
max_secs="$startupwait"
else
shift
fi
local host="${1:-}"
5 years ago
local ports="${*:2}"
local retry_interval="${RETRY_INTERVAL:-1}"
if [ -z "$host" ]; then
echo "$FUNCNAME: host \$2 not set"
exit 1
elif [ -z "$ports" ]; then
echo "$FUNCNAME: ports \$3 not set"
exit 1
else
for port in $ports; do
if ! [[ "$port" =~ ^[[:digit:]]+$ ]]; then
echo "$FUNCNAME: invalid non-numeric port argument '$port'"
exit 1
fi
done
fi
if ! [[ "$retry_interval" =~ ^[[:digit:]]+$ ]]; then
echo "$FUNCNAME: invalid non-numeric \$RETRY_INTERVAL '$retry_interval'"
exit 1
fi
#local max_tries=$(($max_secs / $retry_interval))
# Linux nc doens't have -z switch like Mac OSX version
local nc_cmd="nc -vw $retry_interval $host <<< ''"
cmd=""
for x in $ports; do
cmd="$cmd ! $nc_cmd $x &>/dev/null && "
done
local cmd="${cmd% && }"
5 years ago
# shellcheck disable=SC2086
plural_str $ports
echo "waiting for up to $max_secs secs for port$plural '$ports' to go down, retrying at $retry_interval sec intervals"
echo "cmd: ${cmd// \&\>\/dev\/null}"
local down=0
if type -P nc &>/dev/null; then
#for((i=1; i <= $max_tries; i++)); do
try_number=0
# special built-in that increments for script runtime, reset to zero exploit it here
SECONDS=0
# bash will interpolate from string for correct numeric comparison and safer to quote vars
while [ "$SECONDS" -lt "$max_secs" ]; do
5 years ago
((try_number+=1))
timestamp "$try_number trying host '$host' port(s) '$ports'"
5 years ago
if eval "$cmd"; then
down=1
break
fi
sleep "$retry_interval"
done
if [ $down -eq 1 ]; then
timestamp "host '$host' port$plural '$ports' down after $SECONDS secs"
else
timestamp "host '$host' port$plural '$ports' still not down after '$max_secs' secs, giving up waiting"
return 1
fi
else
echo "WARNING: nc command not found in \$PATH, cannot check for ports down, skipping port checks, tests may fail due to race conditions on service availability"
echo "sleeping for '$max_secs' secs instead"
8 years ago
sleep "$max_secs"
8 years ago
fi
}
8 years ago
when_url_content(){
7 years ago
local max_secs="${1:-}"
if ! [[ "$max_secs" =~ ^[[:digit:]]+$ ]]; then
max_secs="$startupwait"
else
shift
fi
local url="${1:-}"
local expected_regex="${2:-}"
5 years ago
local args="${*:3}"
local retry_interval="${RETRY_INTERVAL:-1}"
if [ -z "$url" ]; then
echo "$FUNCNAME: url \$2 not set"
exit 1
elif [ -z "$expected_regex" ]; then
echo "$FUNCNAME: expected content \$3 not set"
exit 1
fi
if ! [[ "$retry_interval" =~ ^[[:digit:]]+$ ]]; then
echo "$FUNCNAME: invalid non-numeric \$RETRY_INTERVAL '$retry_interval'"
exit 1
fi
#local max_tries=$(($max_secs / $retry_interval))
echo "waiting up to $max_secs secs at $retry_interval sec intervals for HTTP interface to come up with expected regex content: '$expected_regex'"
7 years ago
found=0
#for((i=1; i <= $max_tries; i++)); do
try_number=0
# special built-in that increments for script runtime, reset to zero exploit it here
SECONDS=0
# bash will interpolate from string for correct numeric comparison and safer to quote vars
if type -P curl &>/dev/null; then
7 years ago
while [ "$SECONDS" -lt "$max_secs" ]; do
5 years ago
((try_number+=1))
7 years ago
timestamp "$try_number trying $url"
5 years ago
# shellcheck disable=SC2086
if curl -skL --connect-timeout 1 --max-time 5 ${args:-} "$url" | grep -Eq -- "$expected_regex"; then
7 years ago
echo "URL content detected '$expected_regex'"
found=1
break
fi
sleep "$retry_interval"
done
if [ $found -eq 1 ]; then
timestamp "URL content found after $SECONDS secs"
else
timestamp "URL content still not available after '$max_secs' secs, giving up waiting"
return 1
fi
7 years ago
else
7 years ago
echo "WARNING: curl command not found in \$PATH, cannot check url content, skipping content checks, tests may fail due to race conditions on service availability"
echo "sleeping for '$max_secs' secs instead"
sleep "$max_secs"
7 years ago
fi
}
retry(){
local max_secs="${1:-}"
local retry_interval="${RETRY_INTERVAL:-1}"
shift
if ! [[ "$max_secs" =~ ^[[:digit:]]+$ ]]; then
echo "ERROR: non-integer '$max_secs' passed to $FUNCNAME() for \$1"
exit 1
fi
if ! [[ "$retry_interval" =~ ^[[:digit:]]+$ ]]; then
echo "$FUNCNAME: invalid non-numeric \$RETRY_INTERVAL '$retry_interval'"
exit 1
fi
local negate=""
expected_return_code="${ERRCODE:-0}"
if [ "$1" == '!' ]; then
negate=1
shift
fi
5 years ago
local cmd="${*:-}"
if [ -z "$cmd" ]; then
echo "ERROR: no command passed to $FUNCNAME() for \$3"
exit 1
fi
echo "retrying for up to $max_secs secs at $retry_interval sec intervals:"
7 years ago
try_number=0
SECONDS=0
while true; do
5 years ago
((try_number+=1))
7 years ago
echo -n "try $try_number: "
set +e
$cmd
returncode=$?
set -e
7 years ago
if [ -n "$negate" ]; then
if [ $returncode != 0 ]; then
7 years ago
timestamp "Command failed after $SECONDS secs"
break
fi
5 years ago
elif [ "$returncode" = "$expected_return_code" ]; then
timestamp "Command succeeded with expected exit code of $expected_return_code after $SECONDS secs"
break
fi
5 years ago
if [ "$SECONDS" -gt "$max_secs" ]; then
7 years ago
timestamp "FAILED: giving up after $max_secs secs"
7 years ago
return 1
fi
sleep "$retry_interval"
done
}
5 years ago
timeout(){
if is_mac; then
gtimeout "$@"
else
timeout "$@"
fi
}
5 years ago
usage(){
5 years ago
local args=""
local switches=""
local description=""
5 years ago
if [ -n "${usage_args:-}" ]; then
args="$usage_args"
fi
if [ -n "${usage_switches:-}" ]; then
switches="$usage_switches"
4 years ago
switches="${switches##[[:space:]]}"
switches="${switches%%[[:space:]]}"
5 years ago
fi
if [ -n "${usage_description:-}" ]; then
description="$usage_description
"
fi
5 years ago
if [ -n "$*" ]; then
4 years ago
echo "$*" >&2
echo >&2
5 years ago
fi
4 years ago
cat >&2 <<EOF
$description
5 years ago
usage: ${0##*/} $args
5 years ago
5 years ago
$switches
4 years ago
-h --help Print usage help and exit
5 years ago
EOF
exit 3
}
5 years ago
min_args(){
local min="$1"
shift || :
if [ $# -lt "$min" ]; then
usage "error: missing arguments"
fi
}
4 years ago
max_args(){
local max="$1"
shift || :
if [ $# -gt "$max" ]; then
usage "error: too many arguments, expected $max, got $#"
fi
}
4 years ago
num_args(){
4 years ago
local num="$1"
shift || :
4 years ago
min_args "$num" "$@"
max_args "$num" "$@"
4 years ago
}
5 years ago
help_usage(){
for arg; do
case "$arg" in
-h|--help) usage
;;
esac
done
}
5 years ago
any_opt_usage(){
for arg; do
case "$arg" in
-*) usage
;;
esac
done
}
4 years ago
no_more_opts(){
any_opt_usage "$@"
}
5 years ago
5 years ago
check_env_defined(){
local env="$1"
5 years ago
if [ -z "${!env:-}" ]; then
5 years ago
usage "\$$env not defined"
fi
}
4 years ago
4 years ago
check_yes(){
local answer="$1"
shopt -s nocasematch
if ! [[ "$answer" =~ ^(y|yes)$ ]]; then
echo "Aborting..." >&2
exit 1
fi
shopt -u nocasematch
}
4 years ago
is_int(){
local arg="$1"
[[ "$arg" =~ ^[[:digit:]]+$ ]]
}
is_float(){
local arg="$1"
[[ "$arg" =~ ^[[:digit:]]+(\.[[:digit:]]+)?$ ]]
}
4 years ago
4 years ago
# ============================================================================ #
# JSON utils
# ============================================================================ #
is_blank(){
[ -z "${*:-}" ] || [ "${*##[:space:]}" = "" ]
}
not_blank(){
! is_blank "$*"
}
is_null(){
is_blank "${*:-}" || [ "$*" = null ]
}
not_null(){
! is_null "$*"
}
has_error_field(){
# shellcheck disable=SC2181
if [ $? != 0 ]; then
return 0
elif [ "$(jq -r '.error' <<< "$*" || :)" != null ]; then
return 0
4 years ago
elif [ "$(jq -r '.errors' <<< "$*" || :)" != null ]; then
return 0
4 years ago
elif [ "$(jq -r '.error_description' <<< "$*" || :)" != null ]; then
return 0
fi
return 1
}
die_if_error_field(){
if [ -z "$*" ]; then
echo "no json string passed to die_if_error_field()" >&2
exit 1
fi
if has_error_field "$*"; then
echo "$*" >&2
exit 1
fi
}